#!/usr/bin/puppybasic
option explicit
DIM STARTDIR
include "/usr/lib/wxbasicscript/basefunctions2.inc"

Dim c = 0
Dim h = 0
Dim z = 0
Dim theline
Dim writeback = 0

DIM jwmmenu = readfiletolist("/root/.jwmrc")
DIM newmenu1 = {}
DIM newmenu2 = {}
DIM newmenu3 = {}
DIM jentry

Dim param = argvtostring()
Dim params = explode( param , "" )
Dim pupgetmenu =  params[0]
DIM menufile  = params[1]

'DIM menufile  = argvtostring()

shell ("mkdir /root/.packages/menus 2>/dev/null") 

  Dim menu = readfiletolist( menufile )

   Dim section = ""
   Dim title = ""
   Dim longtitle = ""
   Dim prog = ""
   Dim icon = ""

Dim menuline = ""
c = 0
for each theline in menu
  if c>0 then
    if right ( menu[c] , 1 ) = "\\" then
      menu[c] = cutright( menu[c] , "\\" )
    end if
    menuline &= trim(menu[c])
  end if
  c += 1
next

'print menuline

   if menu[0] != nothing then
   if instr( menu[0] , "section=" ) then
     section = cutleft ( menu[0] , "section=" )
     section = cutright ( section , "\\" )
     section = replace( section , "\"" , "" )
     section = cutleftfromright ( section , "/" )
     section = trim ( section )
   else
     if instr( menuline , "section=\"" ) then
         section = cutleft ( menuline , "section=\"" )
         section = cutrightfromleft (  section , "\"" )
     end if
   end if
   end if

    if section = "" then 
      section = "various"
    end if

  if instr( menuline , "title=\"" ) then

         title = cutleft ( menuline , "title=\"" )
         title = cutrightfromleft (  title , "\"" )

  end if
  if instr( menuline , "longtitle=\"" ) then

         longtitle = cutleft ( menuline , "longtitle=\"" )
         longtitle = cutrightfromleft (  longtitle , "\"" )
         title &= " - " & longtitle
  end if
  if instr( menuline , "command=\"" ) then

         prog = cutleft ( menuline , "command=\"" )
         prog = cutrightfromleft (  prog , "\"" )

  end if
 

  if instr( menuline , "icon=\"" ) then

         icon = cutleft ( menuline , "icon=\"" )
         icon = cutrightfromleft (  icon , "\"" )

  end if

  if instr( menuline , "icon16x16=\"" ) then

         icon = cutleft ( menuline , "icon16x16=\"" )
         icon = cutrightfromleft (  icon , "\"" )

  end if

  if icon = "" then
    icon = "MUCpuppypaw.xpm"
  end if

   DIM   args =  title & "" & prog  & "" & section & "" & icon & "" & "\"" 


// ./adddebianmenu.pb gqview pictureviewergqviewGraficsgqview.xpm

'DIM args  = argvtostring()
if ! instr( args , "" ) then
  print "missing arguments"
  end
end if

DIM arglist = explode( args , "" )


DIM mtitle = arglist[0]
DIM mprog =  arglist[1]
DIM mcat = arglist[2]
DIM micon = arglist[3]
Dim caticon = replace( mcat , " " , "_") & ".xpm"

DIM maincatexists = 0
DIM catexists = 0
DIM progexists = 0


for each jentry in jwmmenu

  if instr( jentry , "<!-- MUCat MainCategory -->" ) then
    maincatexists = 1
  end if
  if instr( jentry , "<!-- MUCat " & mcat & " -->" ) then
    catexists = 1
  end if
next

// -- add the main -category if it does not exist
c = 0
h = 0
if maincatexists = 0 then
  writeback = 1
  for each jentry in jwmmenu
    newmenu1[c+h] = jentry
    if instr( jentry , "<Menu label=\"DotPups\"") then
      h+=1
      newmenu1[c+h] = "<!-- MUCat MainCategory -->"
      h+=1
      newmenu1[c+h] = "<Menu label=\"Categories\" icon=\"MUCategories.xpm\">"
      h += 1
      newmenu1[c+h]  = "</Menu>"
      h += 1
      newmenu1[c+h] = "<!-- MUCat /MainCategory -->"
    end if
    c += 1
  next
else
  for each jentry in jwmmenu
    newmenu1[c] = jentry
    c += 1
  next
end if


// -- add the program -category if it does not exist
c = 0
h = 0
if catexists = 0 then
  writeback = 1
  for each jentry in newmenu1
    if jentry != "deleted" then
      newmenu2[c+h] = jentry
    end if
    if instr( jentry , "<!-- MUCat MainCategory -->" ) then
      h+=1
      newmenu2[c+h] = newmenu1[c+1]
      h+=1
      newmenu2[c+h] = "<!-- MUCat " & mcat & " -->"
      h += 1
      newmenu2[c+h]  = "<Menu label=\"" & mcat & "\" icon=\"" & caticon & "\">" 
      h += 1
      newmenu2[c+h] = "</Menu>"
      h += 1
      newmenu2[c+h] = "<!-- MUCat /" & mcat & " -->"

      newmenu1[c+1] = "deleted"
    end if
    c += 1
  next
else
  for each jentry in newmenu1
    newmenu2[c] = jentry
    c += 1
  next
end if

//--- now check, if the program exists in the desired category

DIM mstart = 0
Dim catpos = 0
c = 0
  for each jentry in newmenu2
    if instr( jentry , "<!-- MUCat MainCategory -->" ) then
      mstart += 1
    end if
    if instr( jentry , "<!-- MUCat /MainCategory -->" ) then
      mstart -= 1
    end if
     if instr( jentry , "<!-- MUCat " & mcat & " -->" ) then
      mstart += 1
      catpos = c + 1
    end if
    if instr( jentry , "<!-- MUCat /" & mcat & " -->" ) then
      mstart -= 1
    end if

    if mstart = 2 then
    if instr( jentry , "<Program label=\"" & mtitle & "\" icon=\"" & micon & "\">" &  mprog & "</Program>") then
      progexists = 1
    end if
    end if
  
    c += 1
  next

if progexists = 1 then
  if writeback = 1 then
    writelisttofile( "/root/.jwmrc" , newmenu2 )
  end if
  end
end if

c = 0
h = 0
for each jentry in newmenu2

  newmenu3[c+h] = jentry

  if c = catpos then
    addprogram()
  end if

   c += 1
next

writelisttofile( "/root/.jwmrc" , newmenu3 )
end

sub addprogram()

  h += 1
  newmenu3[c+h]  = "<Program label=\"" & mtitle & "\" icon=\"" & micon & "\">" & mprog & "</Program>" 
  appendstringtofile( "/root/.packages/menus/" & pupgetmenu & ".menu" , mprog & ""& mtitle  & "" & section  & "" & micon )
   print "<p><font color=green>added menuentry " & title & " in Dotpups - Categories - " & section & "</font><p>" 


end sub






